unit Colle;

interface

uses
  SysUtils,WinTypes,WinProcs,Messages,Classes,Graphics,Controls,
  Forms,Dialogs,IniFiles,StdCtrls,ExtCtrls,Menus,Tabs;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Pop1: TPopupMenu;
    Suppr1: TMenuItem;
    Label1: TLabel;
    TabSet1: TTabSet;
    Etiquet1: TLabel;
    Etiquet2: TLabel;
    Etiquet3: TLabel;
    Etiquet4: TLabel;
    Editer1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Size1: TMenuItem;
    Apropos1: TMenuItem;
    N2: TMenuItem;
    Copier1: TMenuItem;
    Couper1: TMenuItem;
    Coller1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure Suppr1Click(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure Etiquet2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Etiquet2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Editer1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Etiquet2DblClick(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Pop1Popup(Sender: TObject);
    procedure Enregistrer;
    procedure Coller1Click(Sender: TObject);
    procedure TabSet1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);

  private
    { Dclarations private }

  public
    { Dclarations public }
  end;

var
  Form1: TForm1;
  Index:Integer;
  CollIni:TIniFile;
  EtiquetCol,MemColor:TColor;
  Mem1,Mem2,Mem2H,Mem3,Mem3H,Mem4,Mem4H:String;

implementation

{$R *.DFM}

Uses Edicion,Alerte;

var
Objet:Tobject;
x1:integer;
MemEtiquet:Array[2..4] of String;
Ouverture:Boolean;

{A LA CREATION}
procedure TForm1.FormCreate(Sender: TObject);
Var
AllowChange:Boolean;
Ini:TIniFile;
x:Integer;
S:String;
begin
screen.cursor:=crhourglass;
   {CREATION DU FICHIERS INI...}
   if GetDriveType(Ord(Application.ExeName[1])-65)<>DRIVE_fixed
   {...DANS WINDOWS SI DEPART D'UN DISQUE AUTRE QUE DUR...}
   then CollIni:=TIniFile.Create('MezColle.ini')
   {...SINON DANS REPERTOIRE DE L'EXE.}
   else CollIni:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'MezColle.ini');

   {Rapatrier Ini de c:\windows SI ncessaire.}
   if CollIni.ReadInteger('Coller','Left',-500)=-500 then
   begin
   Ini:=TIniFile.create('Mezou.INI');
      if Ini.ReadString('Tous programmes','Coller','')<>''then
      begin
      Ini.WriteString('Tous programmes','Coller','');
      CollIni.WriteInteger('Coller','Left',Ini.ReadInteger('Coller','Left',20));
      CollIni.WriteInteger('Coller','Top',Ini.ReadInteger('Coller','Top',20));
      CollIni.WriteInteger('Coller','Scroll',Ini.ReadInteger('Coller','Scroll',0));
      CollIni.WriteInteger('Coller','Index',Ini.ReadInteger('Coller','Index',0));
         for x:=0 to 9 do
         begin
         S:=IntToStr(x);
         CollIni.WriteString('Coller',S+'Col',Ini.ReadString('Coller',S+'Col','clMaroon'));
         CollIni.WriteString('Coller',S+'1',Ini.ReadString('Coller',S+'1','Rien'));
         CollIni.WriteString('Coller',S+'2',Ini.ReadString('Coller',S+'2','Vide'));
         CollIni.WriteString('Coller',S+'2H',Ini.ReadString('Coller',S+'2H',''));
         CollIni.WriteString('Coller',S+'3',Ini.ReadString('Coller',S+'3','Vide'));
         CollIni.WriteString('Coller',S+'3H',Ini.ReadString('Coller',S+'3H',''));
         CollIni.WriteString('Coller',S+'4',Ini.ReadString('Coller',S+'4','Vide'));
         CollIni.WriteString('Coller',S+'4H',Ini.ReadString('Coller',S+'4H',''));
         end;
      Ini.EraseSection('Coller');
      Ini.Free;
      end;
   end;
Ouverture:=True;
Left:=CollIni.ReadInteger('Coller','Left',20);
Top:=CollIni.ReadInteger('Coller','Top',20);
ClientWidth:=112;
ClientHeight:=86;
Label1.Top:=0;
Label1.Left:=2;
Suppr1.Checked:=CollIni.ReadBool('Coller','Supprimer',False);
TabSet1.AutoScroll:=CollIni.ReadBool('Coller','Scroll',False);

x1:=-2;
   if ParamStr(1)<>'' then
   begin
   x1:=StrToIntDef(ParamStr(1)[1],-2)-1;
      if Pos('/',ParamStr(1))<>0
      then x1:=StrToIntDef(ParamStr(1)[2],-2)-1;
      if x1=-1
      then x1:=9;
   end;
   if x1<0
   then x1:=CollIni.ReadInteger('Coller','Index',0);
TabSet1.TabIndex:=x1;
TabSet1Change(TabSet1,x1,AllowChange);
Mem1:='';
screen.cursor:=crdefault;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (key>95)
   and (Key<106)then
   begin
   x1:=Key-96;
      if x1=0
      then x1:=10;
   TabSet1.TabIndex:=x1-1;
   end;

if key=vk_escape then close;

end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
Close;
end;

{A LA FERMETURE...}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
{CollIni.WriteBool('Coller','Supprimer',Suppr1.Checked);}
CollIni.WriteBool('Coller','Scroll',TabSet1.AutoScroll);
CollIni.WriteInteger('Coller','Left',Left);
CollIni.WriteInteger('Coller','Top',Top);
   if (Etiquet2.Hint<>'')and (Etiquet3.Hint<>'')
   and(Etiquet4.Hint<>'')
   then CollIni.WriteInteger('Coller','Index',TabSet1.TabIndex);
end;

{Click sur un truc  coller...}
procedure TForm1.Etiquet2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if Pos('vide',LowerCase(TLabel(Sender).Caption))<>0
   then Exit;
Objet:=Sender;
EtiquetCol:=TLabel(Sender).Color;
TLabel(Sender).Color:=clGreen;
TLabel(Objet).Font.Color:=clLime;
Timer1.Enabled:=True;
end;

{Tant que le Click n'est pas lach...}
procedure TForm1.Timer1Timer(Sender: TObject);
begin
   if TLabel(Objet).Font.Color=clOlive
   then TLabel(Objet).Font.Color:=clLime
   else TLabel(Objet).Font.Color:=clOlive;
end;

{Le Click est lach...
On colle le Hint (S) du Choix (Objet) dans la fentre (Hwnd).}
procedure TForm1.Etiquet2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
P:TPoint;
Hwnd:THandle;
S:String;
R1:PCHar;
begin
   if Pos('vide',LowerCase(TLabel(Sender).Caption))<>0
   then Exit;
Timer1.Enabled:=False;
TLabel(sender).Color:=EtiquetCol;
TLabel(sender).Font.Color:=clWhite;
S:=TLabel(sender).Hint;
GetCursorPos(P);
Hwnd:=WindowFromPoint(P);
   if Hwnd=Handle then exit;
   {Supprimer "*" de mot de passe.}
   {if Suppr1.Checked}
   if (ssCtrl in shift) and  (ssAlt in shift)
   then SendMessage(Hwnd,EM_SETPASSWORDCHAR,0,0);

{Prparation de:  "Ecrire Sender.Hint (S) dans la fentre choisie".}
R1:=StrAlloc(Length(S)+1);
R1:='';
StrPCopy(R1,S);
{Ecrire Sender.Hint (S) dans la fentre choisie.}
SendMessage(Hwnd,WM_SETTEXT,0,LongInt(R1));
StrDispose(R1);
end;

{CHOIX DE LA PAGE....}
procedure TForm1.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
S:String;
begin
Index:=NewTab;
Editer1.Caption:='Editer Page No '+IntToStr(Index+1);
EtiquetCol:=StringToColor(CollIni.ReadString('Coller',IntToStr(Index)+'Col','clMaroon'));
Etiquet2.Color:=EtiquetCol;
Etiquet3.Color:=EtiquetCol;
Etiquet4.Color:=EtiquetCol;
Etiquet1.Caption:=CollIni.ReadString('Coller',IntToStr(Index)+'1','Rien');
Etiquet2.Caption:=CollIni.ReadString('Coller',IntToStr(Index)+'2','Vide');
Etiquet2.Hint:=CollIni.ReadString('Coller',IntToStr(Index)+'2H','');
Etiquet3.Caption:=CollIni.ReadString('Coller',IntToStr(Index)+'3','Vide');
Etiquet3.Hint:=CollIni.ReadString('Coller',IntToStr(Index)+'3H','');
Etiquet4.Caption:=CollIni.ReadString('Coller',IntToStr(Index)+'4','Vide');
Etiquet4.Hint:=CollIni.ReadString('Coller',IntToStr(Index)+'4H','');
MemEtiquet[2]:=Etiquet2.Caption;
MemEtiquet[3]:=Etiquet3.Caption;
MemEtiquet[4]:=Etiquet4.Caption;
end;

{Ouvrir et Fermer.}
procedure TForm1.FormDblClick(Sender: TObject);
begin
   if ClientHeight<86
   then ClientHeight:=86
   else ClientHeight:=14;
Label1.Visible:=Not Label1.Visible;
   if Label1.Visible
   then Size1.Caption:='Agrandir.'
   else Size1.Caption:='Rduire.';
end;

      {LE MENU POPUP....}
{PopUp !!!}
procedure TForm1.Pop1Popup(Sender: TObject);
begin
   if Mem1=''
   then Coller1.Enabled:=False
   else Coller1.Enabled:=True;
   if (Etiquet2.Hint='')and (Etiquet3.Hint='')
   and(Etiquet4.Hint='') then
   begin
   Copier1.Enabled:=False;
   Couper1.Enabled:=False;
   end
   else
   begin
   Copier1.Enabled:=True;
   Couper1.Enabled:=True;
   end;
Editer1.Enabled:=True;
   if Etiquet2.Hint=Etiquet2.Caption
   then Editer1.Enabled:=False;
   if Etiquet3.Hint=Etiquet3.Caption
   then Editer1.Enabled:=False;
   if Etiquet4.Hint=Etiquet4.Caption
   then Editer1.Enabled:=False;
end;

procedure TForm1.Suppr1Click(Sender: TObject);
begin
TMenuItem(Sender).Checked:=Not TMenuItem(Sender).Checked;
end;

{Edition de la page en cours.}
procedure TForm1.Editer1Click(Sender: TObject);
begin
Application.CreateForm(TForm2, Form2);
Form2.ShowModal;
   if Form2.ModalResult=mrYes then
   begin
   Enregistrer;
   end;
Form2.Release;
end;

{Copier, Couper.}
procedure TForm1.Copier1Click(Sender: TObject);
begin
{Copier.}
   if Etiquet2.Caption=Etiquet2.Hint
   then Etiquet2DblClick(Etiquet2);
   if Etiquet3.Caption=Etiquet3.Hint
   then Etiquet2DblClick(Etiquet3);
   if Etiquet4.Caption=Etiquet4.Hint
   then Etiquet2DblClick(Etiquet4);
MemColor:=EtiquetCol;
Mem1:=Etiquet1.Caption;
Mem2:=Etiquet2.Caption;
Mem2H:=Etiquet2.Hint;
Mem3:=Etiquet3.Caption;
Mem3H:=Etiquet3.Hint;
Mem4:=Etiquet4.Caption;
Mem4H:=Etiquet4.Hint;
   {Couper.}
   if TMenuItem(Sender).Tag=1 then
   begin
   EtiquetCol:=clMaroon;
   Etiquet1.Caption:='Rien';
   Etiquet2.Caption:='Vide';
   Etiquet2.Hint:='';
   Etiquet3.Caption:='Vide';
   Etiquet3.Hint:='';
   Etiquet4.Caption:='Vide';
   Etiquet4.Hint:='';
   end;
Enregistrer;
end;

{Coller}
procedure TForm1.Coller1Click(Sender: TObject);
begin
EtiquetCol:=MemColor;
Etiquet1.Caption:=Mem1;
Etiquet2.Caption:=Mem2;
Etiquet2.Hint:=Mem2H;
Etiquet3.Caption:=Mem3;
Etiquet3.Hint:=Mem3H;
Etiquet4.Caption:=Mem4;
Etiquet4.Hint:=Mem4H;
Enregistrer;
end;
      {FIN DE: LE MENU POPUP....}

procedure TForm1.Enregistrer;
begin
CollIni.WriteString('Coller',IntToStr(Index)+'Col',ColorToString(EtiquetCol));
CollIni.WriteString('Coller',IntToStr(Index)+'1',Etiquet1.Caption);
CollIni.WriteString('Coller',IntToStr(Index)+'2',Etiquet2.Caption);
CollIni.WriteString('Coller',IntToStr(Index)+'2H',Etiquet2.Hint);
CollIni.WriteString('Coller',IntToStr(Index)+'3',Etiquet3.Caption);
CollIni.WriteString('Coller',IntToStr(Index)+'3H',Etiquet3.Hint);
CollIni.WriteString('Coller',IntToStr(Index)+'4',Etiquet4.Caption);
CollIni.WriteString('Coller',IntToStr(Index)+'4H',Etiquet4.Hint);
Etiquet2.Color:=EtiquetCol;
Etiquet3.Color:=EtiquetCol;
Etiquet4.Color:=EtiquetCol;
MemEtiquet[2]:=Etiquet2.Caption;
MemEtiquet[3]:=Etiquet3.Caption;
MemEtiquet[4]:=Etiquet4.Caption;
end;

{Voir les mots de Passe.}
procedure TForm1.Etiquet2DblClick(Sender: TObject);
begin
   if Pos('vide',LowerCase(TLabel(Sender).Caption))<>0
   then Exit;
   if TLabel(Sender).Caption=TLabel(Sender).Hint
   then TLabel(Sender).Caption:=MemEtiquet[TLabel(Sender).Tag]
   else TLabel(Sender).Caption:=TLabel(Sender).Hint;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
ShowMessage('MezColle.exe: FreeWare de Mezou Prod.'#13+
'Ce logiciel est livr "Tel que", sans AUCUNE garantie ni AUCUN support.');
ShowMessage('Mezou Prod'#13#13'EMail: jjroue@ifrance.com'#13+
            '        jean-jacques.roue@worldonline.fr'#13#13+
            'Web:   www.ifrance.com/MezouProd');
end;

procedure TForm1.TabSet1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if Button=mbRight
   then TabSet1.AutoScroll:=Not TabSet1.AutoScroll;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key=37) then
   begin
   x1:=Index-1;
      if x1<0
      then x1:=9;
   TabSet1.TabIndex:=x1;
   end;
   if (Key=39) then
   begin
   x1:=Index+1;
      if x1>9
      then x1:=0;
   TabSet1.TabIndex:=x1;
   end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
x,xx:Integer;
begin
   if Not Ouverture
   then Exit;
Ouverture:=False;
x:=CollIni.ReadInteger('Coller','Lui',0);
xx:=StrToInt(FormatDateTime('mm',Now));
   if x<>xx then
   begin
   CollIni.WriteInteger('Coller','Lui',xx);
   CollIni.WriteBool('Coller','Repete',False);
   x:=CollIni.ReadInteger('Coller','How',0);
      if x>8
      then CollIni.WriteInteger('Coller','How',8);
   end;
   if Not CollIni.ReadBool('Coller','Repete',False) then
   begin
   Application.CreateForm(TForm3, Form3);
   Form3.ShowModal;
   Form3.Release;
   end;

end;

end.
